#ifndef CONTEXTMEDIAAPPDOCUMENT_H
#define CONTEXTMEDIAAPPDOCUMENT_H

#include <akndoc.h>
#include "app_context.h"
#include "cl_settings.h"
#include "cm_storage.h"
#include "cm_network.h"
#include "app_local_settings.h"
#include "app_context_impl.h"
#include "cl_settings.h"
#include "cl_settings_impl.h"

class  CEikAppUi;

class CContextMediaAppDocument : public CAknDocument
    {
    public:
        static CContextMediaAppDocument* NewL(CEikApplication& aApp);
        virtual ~CContextMediaAppDocument();

    private:

        CContextMediaAppDocument(CEikApplication& aApp);
        void ConstructL();
	void InnerConstructL();

	CApp_context* iContext;
	CDb *				iThreadStorageDb;
	CBBSession*			iBBSession;
	CBBDataFactory*			iBBDataFactory;
	CPostStorage *			iThreadStorage;
	CCMNetwork*			iNetwork;
	TNoDefaults iNoDefaults;
	class CDebugScheduler*		iDebugScheduler;
	CActiveScheduler*		iBuiltinScheduler;
	TClSettings iDefaultSettings;

    private:
        CEikAppUi* CreateAppUiL();
    };
#endif


