/* 
    Copyright (C) 2004  Mika Raento - Renaud Petit

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    email: mraento@cs.helsinki.fi - petit@cs.helsinki.fi 
*/

/*
 * FIXME: we should use active objects and the active scheduler. The
 * code is a mess.
 */

#include <e32base.h>
#include <e32cons.h>
#include <stdlib.h>
#include <apgcli.h>
#include <apgtask.h>
#include <w32std.h>
#include <saclient.h>

#include "app_context.h"
#include "app_context_impl.h"
#include "file_output_base.h"

#include "context_uids.h"
#include "callstack.h"
#include <bautils.h>
#ifdef __S60V2__
#include <sysutil.h>
#endif
#include <APACMDLN.H>
#include <eikdll.h>

const TUid KUidPhone = { 0x100058b3 };
const TUid KUidMenu = {  0x101f4cd2 };

const TInt KUidToBackgroundValue=0x2004;
const TUid KUidToBackground={KUidToBackgroundValue};

class TFileStack : public MCallStackVisitor {
public:
	TFileStack(Cfile_output_base& aInto) : iInto(aInto) { }
private:
	virtual void BeginStack()
	{
		iInto.log_message(_L8("Stack trace: "));
	}
	virtual void VisitItem(const TDesC& Name)
	{
		iInto.log_message(Name);
	}
	virtual void EndStack()
	{
	}

	Cfile_output_base& iInto;
};

const TInt KUidSimCStatusValue = 0x100052E9;
const TUid KUidSimCStatus = {KUidSimCStatusValue};
enum TSASimCStatus
        {
        ESACSimInitWait,
        ESACSimLockOperative,
        ESACSimPinVerifyRequired,
        ESACSimPermanentlyBlocked,
        ESACSimRemoved,
        ESACSimRejected,
        ESACSimBlocked,
        ESACSimOk
        };

enum TSWStartupReason
        {
    // Normal startup reasons (100..149)

    // Nothing set the (default value).
    ESWNone = 100,

    // Restore Factory Settings (Normal)
    ESWRestoreFactorySet = 101,

    // Language Switched
    ESWLangSwitch = 102,

    // Warranty transfer
    ESWWarrantyTransfer = 103,

    // Possibly needed for handling
    // power off & charger connected use case.
    ESWChargerConnected = 104,

    // Restore Factory Settings (Deep)
    ESWRestoreFactorySetDeep = 105
        };

class SysStartup {
public:
IMPORT_C static TInt ShutdownAndRestart( const class TUid& aSource, TSWStartupReason aReason);
};

TBool IsInRom(const TApaTask& task)
{
	RThread t; 
	User::LeaveIfError(t.Open(task.ThreadId()));
	CleanupClosePushL(t);
	RProcess p;
	User::LeaveIfError( t.Process(p) );
	CleanupClosePushL(p);
	TBool ret=EFalse;
	HBufC* cmd=HBufC::NewLC(p.CommandLineLength());
	TPtr cmdp=cmd->Des();
	p.CommandLine(cmdp);
	if (cmd->Left(1).CompareF(_L("z"))==0) ret=ETrue;
	CleanupStack::PopAndDestroy(3);
	return ret;
}

// This is the mainloop game loop or whatever
void mainloop(TDes8& aState)
{
	TInt pushed=0;

	HBufC* cmdh=0;
#ifndef __WINS__
	RProcess p=RProcess();
	aState=_L8("cmdh");
	cmdh=HBufC::NewLC( p.CommandLineLength() ); ++pushed;
	TPtr16 cmd=cmdh->Des();
	p.CommandLine(cmd);
#else
	cmdh=HBufC::NewLC(30);  ++pushed;
	TPtr16 cmd=cmdh->Des();
	cmd=_L("context_log*");
	cmd.AppendNum( (TInt)KUidcontext_log.iUid );
#endif

	TBool N70=EFalse;
#ifdef __S60V2__
	{
		HBufC8* agent=SysUtil::UserAgentStringL();
		if ( (*agent).Left(8).Compare(_L8("NokiaN70"))==0) N70=ETrue;
		delete agent;
	}
#endif

#ifdef START_CONTEXT_LOG
	_LIT(Kstartapp_chunkname, "context_log");
	const TUid Kstartapp_uid = { CONTEXT_UID_CONTEXT_LOG };
#else
#  ifdef START_CONTEXTCONTACTS
	_LIT(Kstartapp_chunkname, "contacts");
	const TUid Kstartapp_uid = { CONTEXT_UID_CONTEXTCONTACTS };
#  endif
#endif

	TBuf<30> chunkname;
	TUid appuid;

	aState=_L8("appcontext::newl");
	CApp_context* ctx=CApp_context::NewL(true);
	CleanupStack::PushL(ctx); ++pushed;
	aState=_L8("setdatadir");
	ctx->SetDataDir(_L("c:\\system\\data\\context\\"), false);

	if (cmd.Length() > 0) {
		TLex l(cmd);
		l.Mark();
		while (l.Peek()!='*' && !l.Eos()) {
			l.Inc();
		}
		chunkname=l.MarkedToken();
		l.Inc();
		TInt uid;
		User::LeaveIfError( l.Val(uid) );
		appuid.iUid=uid;
	} else {
		aState=_L8("fileexists_disable");
		if ( BaflUtils::FileExists(ctx->Fs(), _L("c:\\system\\data\\context\\disable_autostart.dat")) ) {
			CleanupStack::PopAndDestroy(pushed); 
			return;
		}
		appuid=Kstartapp_uid;
		chunkname=Kstartapp_chunkname;
	}

	TInt aMaxLogCount=0;
	if ( BaflUtils::FileExists(ctx->Fs(), _L("c:\\system\\apps\\contextflickr\\contextflickr.app")) ) {
		aMaxLogCount=5;
	} 
	if ( BaflUtils::FileExists(ctx->Fs(), _L("e:\\system\\apps\\contextflickr\\contextflickr.app")) ) {
		aMaxLogCount=5;
	} 

	Cfile_output_base *fo=0;
	RTimer timer;
	CConsoleBase* console=0;
	TTime time;
	RApaLsSession ls;
	RWsSession ws;
	aState=_L8("ws.connect");
	User::LeaveIfError(ws.Connect());
	CleanupClosePushL(ws); ++pushed;
	TRequestStatus app_status, timer_status;
	TApaTaskList tl(ws);

	aState=_L8("timer.create");
	timer.CreateLocal();
	CleanupClosePushL(timer); ++pushed;
	aState=_L8("ls.connect");
	User::LeaveIfError(ls.Connect());
	CleanupClosePushL(ls); ++pushed;

	if (1 || cmd.Length()==0) {
		// may be started by autostart with a command line now
		TBuf<30> name=_L("starter-");
		name.Append(chunkname);
		aState=_L8("fo=");
		fo=Cfile_output_base::NewL(*ctx, name, true, false, 5);
		CleanupStack::PushL(fo); ++pushed;

		//console=Console::NewL(_L("starter"),TSize(KConsFullScreen,KConsFullScreen));
		//CleanupStack::PushL(console); ++pushed;

		if (fo) fo->log_message(_L8("waiting for phone start"));
		if (fo && N70) fo->log_message(_L8("N70"));
		// don't start app until phone has actually booted up
#ifndef __WINS__
		RSystemAgent	iAgent;
		aState=_L8("agent.connect");
		User::LeaveIfError(iAgent.Connect());
		CleanupClosePushL(iAgent);
		while ( iAgent.GetState(KUidSimCStatus) != ESACSimOk ) {
#else
		while (! tl.FindApp(KUidMenu).Exists()) {
#endif
			time.HomeTime();
			time+=TTimeIntervalSeconds(30);
			//time+=TTimeIntervalMicroSeconds(50);
			timer.At(timer_status,time);
			User::WaitForRequest(timer_status);
		}
#ifndef __WINS__
			CleanupStack::PopAndDestroy(); // iAgent
#endif
	}

	RChunk stackchunk;
	aState=_L8("openglobal");
	TInt cerr=stackchunk.OpenGlobal(chunkname, EFalse);
	if (cerr!=KErrNone) {
		aState=_L8("createglobal");
		User::LeaveIfError(stackchunk.CreateGlobal(chunkname, 4096, 4096));
		*(TInt*)stackchunk.Base()=0;
	}
	CleanupClosePushL(stackchunk); ++pushed;

	_LIT(filen, "hide"); //dummy

	TThreadId app_threadid;

	//wake up on thread death
	RThread app_thread;
	bool thread_is_open=false;

#ifndef __WINS__
	//TTimeIntervalHours wait_interval(1);
	TTimeIntervalMinutes wait_interval(10);
	TTimeIntervalHours restart_interval(24);
	//TInt restart_on_count=2;
#else
	//TTimeIntervalSeconds wait_interval(5);
	TTimeIntervalMinutes wait_interval(2);
	TTimeIntervalMinutes restart_interval(24);
#endif

	int wait_count=0; // we wait 10 mins at a time for watchdog setting,
			// so count to 24*6...

	time.HomeTime();
#ifdef __WINS__
	time += TTimeIntervalSeconds(1);
#else
	time += TTimeIntervalSeconds(10);
#endif
	if (console) {
		TBuf<30> dt;
		time.FormatL(dt, _L("%F%Y-%M-%D %H:%T:%S\n"));
		console->Printf(dt);
	}

	bool done=false; bool restarting=false; bool doing_restart=false;
	bool logged_on=false;
	int restart_count=0; const int RESTART_MAX=20;
	TInt restart_time=30;

	TTime startedApp; startedApp.HomeTime();
	startedApp-=TTimeIntervalSeconds(10);

	if (cmd.Length()==0) {
		timer.At(timer_status,time);
		app_status=KRequestPending;
		doing_restart=restarting=true;
	} else {

		TTime wait_until; wait_until.HomeTime(); wait_until+=TTimeIntervalSeconds(5);
		TBool app_exists=EFalse;
		TThreadId app_thread_id;
		for(;;) {
			TApaTask app_task=tl.FindApp(appuid);
			if (app_task.Exists()) {
				if ( N70 && IsInRom(app_task)) {
					if (fo) fo->log_message(_L("killing built-in app"));
					app_task.KillTask();
				} else {
					app_thread_id=app_task.ThreadId();
					app_exists=ETrue;
				}
				break;
			}
			TTime now; now.HomeTime();
			if (now > wait_until) break;
			User::After( 1000*1000 );
		}
		if (!app_exists) {
			TTime now; now.HomeTime();
			if (now > time) time=now;
			time+=TTimeIntervalSeconds(1);
			timer.At(timer_status, time);
			app_status=KRequestPending;
			doing_restart=restarting=true;
#ifdef __WINS__
			restart_time=0;
#else
			restart_time=15;
#endif
		} else {
			time.HomeTime();
			time += wait_interval;
			timer.At(timer_status, time);
			aState=_L8("app_thread.open");
			User::LeaveIfError(app_thread.Open(app_thread_id));
			thread_is_open=true;
			app_status=KRequestPending;
			app_thread.Logon(app_status); logged_on=true;
			doing_restart=restarting=false;
			restart_time=15;
		}
	}

	while(!done) {
		//if (fo) fo->log_message(_L8("waiting"));
wait:
		User::WaitForRequest(timer_status, app_status);
		if (timer_status!=KRequestPending && !doing_restart) {
			//if (fo) fo->log_message(_L8("timer expired"));
			RDebug::Print(_L("timer!"));
			if (console) {
				TBuf<30> dt;
				time.FormatL(dt, _L("%F%Y-%M-%D %H:%T:%S\n"));
				console->Printf(_L("%d "), timer_status);
				console->Printf(dt);
			}
			TBool hung=EFalse;

			if (appuid==KUidcontext_log) {
				TEntry e;
				TInt err=ctx->Fs().Entry(
					_L("c:\\system\\data\\context\\watch-context_log.dat"), e);
				TTime now; now.HomeTime();
				now-=wait_interval;
				if (err!=KErrNone || e.iModified < now) {
					hung=ETrue;
					if (!fo) {
						TBuf<100> name=_L("starter-");
						name.Append(chunkname);
						fo=Cfile_output_base::NewL(*ctx, name, true, false, 5);
						CleanupStack::PushL(fo); ++pushed;
					}
					TDateTime dt=now.DateTime();
					TBuf<100> msg;
					msg.Append(_L("now ")); msg.AppendNum(dt.Hour());
					msg.Append(_L(":")); msg.AppendNum(dt.Minute());
					dt=e.iModified.DateTime();
					msg.Append(_L(" filetime ")); msg.AppendNum(dt.Hour());
					msg.Append(_L(":")); msg.AppendNum(dt.Minute());
					fo->log_message(msg);
					if (fo) fo->log_message(_L8("app hung"));
				}
			}
			TTime now; now.HomeTime();
			if (hung || (now > startedApp+restart_interval) ) {
				if (fo) fo->switch_file();
				TApaTask app_task=tl.FindApp(appuid);
				if (!app_task.Exists()) {
					if (fo) fo->log_message(_L8("app already dead"));
					restarting=true;
					doing_restart=true;
				} else {
					if (fo) fo->log_message(_L8("shutting down app "));
					app_task.SendSystemEvent(EApaSystemEventShutdown);

					if (console) console->Printf(_L("shut app\n"));
				}
				restarting=true; restart_count=0;
				wait_count=0;
			} else {
				wait_count++;
			}
			time.HomeTime();
			time += TTimeIntervalSeconds(60);
			timer.At(timer_status, time);
		} 
		if (timer_status!=KRequestPending && restarting && !doing_restart) {
			app_thread.Kill(2003);
			time.HomeTime();
			time += wait_interval;
			timer.At(timer_status, time);
		}
		if (app_status!=KRequestPending || doing_restart) {
			TInt etype=0, ereason=0;
			TExitCategoryName ecat=0;
			if (app_status!=KRequestPending) {
				TApaTask app_task=tl.FindApp(appuid);
				if (app_task.Exists()) {
					app_thread.Close();
					TThreadId app_thread_id=app_task.ThreadId();
					aState=_L8("app_thread.open_2");
					User::LeaveIfError(app_thread.Open(app_thread_id));
					app_status=KRequestPending;
					app_thread.Logon(app_status); logged_on=true;
					etype=ereason=0;
					restarting=false;
					time.HomeTime();
					time+=wait_interval;
					timer.Cancel();
					timer.At(timer_status, time);
					goto wait;
				} else {
					if (fo) fo->log_message(_L8("app stopped"));
					if (console) console->Printf(_L("app stopped\n"));
					logged_on=false;
					etype=app_thread.ExitType();
					ereason=app_thread.ExitReason();
					ecat=app_thread.ExitCategory();
					app_thread.Close(); thread_is_open=false;

					if (etype==0 && appuid==KUidcontext_log) {
						// check that it actually got started
						TEntry e;
						TInt err=ctx->Fs().Entry(
							_L("c:\\system\\data\\context\\watch-context_log.dat"), e);
						if (err!=KErrNone || e.iModified < startedApp) {
							etype=2;
							ecat=_L("DIDNT START");
							if (!fo) {
								TBuf<100> name=_L("starter-");
								name.Append(chunkname);
								fo=Cfile_output_base::NewL(*ctx, name, true, false, 5);
								CleanupStack::PushL(fo); ++pushed;
							}
							TDateTime dt=e.iModified.DateTime();
							TBuf<100> msg;
							msg.Append(_L("watch err ")); msg.AppendNum(err);
							msg.Append(_L(" time ")); msg.AppendNum(dt.Hour());
							msg.Append(_L(":")); msg.AppendNum(dt.Minute());
							fo->log_message(msg);
						}
					}
					if (etype!=0 || ereason!=0) {
						if (!fo) {
							TBuf<100> name=_L("starter-");
							name.Append(chunkname);
							fo=Cfile_output_base::NewL(*ctx, name, true, false, 5);
							CleanupStack::PushL(fo); ++pushed;
						}
						TBuf8<100> msg=_L8("reasons: ");
						msg.AppendNum(etype); msg.Append(_L8(", "));
						msg.AppendNum(ereason); msg.Append(_L8(", "));
						msg.Append(ecat);
						fo->log_message(msg);
						TFileStack fs(*fo);
						ctx->CallStackMgr().IterateStack(fs, (char*)stackchunk.Base());
						*(TInt*)stackchunk.Base()=0;
					}
				}
			}
			
			if ((etype!=0 || (etype==0 && ( ereason==2003 || ereason==2004) ) || restarting) && restart_count<RESTART_MAX) {

				if (ereason==2004 && restart_count > 2) {
					// network's f*cked up
					// better restart the whole phone
					if (!fo) {
						TBuf<100> name=_L("starter-");
						name.Append(chunkname);
						fo=Cfile_output_base::NewL(*ctx, name, true, false, 5);
						CleanupStack::PushL(fo); ++pushed;
					}
					if (fo) fo->log_message(_L8("restarting phone"));
					delete fo; fo=0;
					timer.Cancel();
					TTimeIntervalMicroSeconds32 w(120*1000*1000);
					timer.After(timer_status, w);
					User::WaitForRequest(timer_status);
					TUid t={0x101FBAD3};
					SysStartup::ShutdownAndRestart( t, ESWNone);
					TTimeIntervalMicroSeconds32 w2(30*1000*1000);
					timer.After(timer_status, w2);
					User::WaitForRequest(timer_status);
				}
				if (fo) fo->log_message(_L8("restarting app"));
				time.HomeTime();
				time+=TTimeIntervalSeconds(restart_time);
				restart_time=30;
				timer.Cancel();
				timer.At(timer_status, time);
				User::WaitForRequest(timer_status);

				TInt err;
				if (!N70 || (appuid!=KUidContextContacts && appuid!=KUidContextCallLog) ) {
					err=ls.StartDocument(filen, appuid, app_threadid);
				} else {
					TFileName *fnp=new (ELeave) TFileName;
					TFileName& fn=*fnp;
					if ( appuid == KUidContextContacts ) {
						fn=_L("c:\\system\\apps\\contextcontacts\\contextcontacts.app");
					} else {
						fn=_L("c:\\system\\apps\\contextcalllog\\contextcalllog.app");
					}
					if (! BaflUtils::FileExists(ctx->Fs(), fn) ) {
						fn.Replace(0, 1, _L("e"));
					}
					auto_ptr<CApaCommandLine> cmd(CApaCommandLine::NewL(fn));
					cmd->SetCommandL(EApaCommandBackground);
					//err=ls.StartApp(*cmd);
					TRAP(err, app_threadid=EikDll::StartAppL(*cmd));
					delete fnp;
				}
				restart_count++;
				if (err==KErrNone) {
					startedApp.HomeTime();
					startedApp-=TTimeIntervalSeconds(10);
					if (fo) fo->log_message(_L8("success in restarting app"));
					if (logged_on) {
						app_thread.LogonCancel(app_status);
						logged_on=false;
					}
					if (thread_is_open) {
						app_thread.Close();
						thread_is_open=false;
					}
	
					err=app_thread.Open(app_threadid);

					if (err==KErrNone) {
						thread_is_open=true;
						app_thread.Logon(app_status);
						logged_on=true;
						restarting=false;
						doing_restart=false;
						
						time.HomeTime();
						time+=wait_interval;
						timer.At(timer_status, time);
					}
					else
					{
						if (fo) fo->log_message(_L8("test"));
					}
				} 
				if (err!=KErrNone) {
					TBuf<30> msg;
					msg.Format(_L("Error starting %d\n"), err);
					if (console) {
						console->Printf(msg);
					}
					if (fo) fo->log_message(msg);
					doing_restart=true;
					time.HomeTime();
					time+=TTimeIntervalSeconds(30);
					timer.Cancel();
					timer.At(timer_status, time);
					restarting=true;
				}
			} else {
				// user shutdown
				done=true;
			}
		}
	}
	if (fo) fo->log_message(_L8("stopping"));
	if (logged_on) app_thread.LogonCancel(app_status);
	if (thread_is_open) app_thread.Close();
	if (console) {
		console->Getch(); // get and ignore character
	}
	CleanupStack::PopAndDestroy(pushed); //console, ws, ls, timer

}

_LIT(KTxtEPOC32EX,"STARTER");


void reporterror(TInt error, const TDesC8& state)
{
	RFs fs; if (fs.Connect()!=KErrNone) return;
	RFile f; 
	if (f.Replace(fs, _L("c:\\system\\data\\context\\starter_error.txt"), EFileWrite|EFileShareAny)
		==KErrNone) {

		f.Write(_L8("Error in starter: "));
		TBuf8<12> b; b.AppendNum(error); b.Append(_L8("\n"));
		f.Write(b);
		f.Write(state);
		f.Close();
	}
	fs.Close();
}

#ifdef __WINS__

EXPORT_C TInt InitEmulator() // mainloop function called by the emulator software
{
	__UHEAP_MARK;
	CTrapCleanup* cleanup=CTrapCleanup::New(); // get clean-up stack
	TBuf8<80> state;
	TRAPD(error,mainloop(state)); // more initialization, then do example
	if (error!=KErrNone) reporterror(error, state);
	__ASSERT_ALWAYS(!error,User::Panic(KTxtEPOC32EX,error));
	delete cleanup; // destroy clean-up stack
	__UHEAP_MARKEND;
	
	//CloseSTDLIB();
	User::Exit(0);
	
	return KErrNone;
}

int GLDEF_C E32Dll(TDllReason)
{
	return(KErrNone);
}

#else

GLDEF_C TInt E32Main() // mainloop function called by E32
{
	__UHEAP_MARK;
	CTrapCleanup* cleanup=CTrapCleanup::New(); // get clean-up stack
	TBuf8<80> state;
	TRAPD(error,mainloop(state)); // more initialization, then do example
	if (error!=KErrNone) reporterror(error, state);
	__ASSERT_ALWAYS(!error,User::Panic(KTxtEPOC32EX,error));
	delete cleanup; // destroy clean-up stack
	__UHEAP_MARKEND;
	
	//CloseSTDLIB();
	User::Exit(0);
	
	return KErrNone; // and return
}

#endif

